#include "Ball.h"


Ball::Ball(double x, double y, double angle) {
	Ball::setPosition(x, y);
	Ball::setAngle(angle);
}


Ball::~Ball(void) {
}


void Ball::setPosition(double x, double y) {
	Ball::x = x;
	Ball::y = y;
}


void Ball::setAngle(double angle) {
	double offset;
	Ball::angle = angle;

	if (Ball::angle < 0) {
		Ball::angle = angle + 360;
	}

	if (Ball::angle > 359) {
		Ball::angle = angle - 360;
	}
}


double Ball::getX(void) {
	return Ball::x;
}


double Ball::getY(void) {
	return Ball::y;
}


double Ball::getAngle(void) {
	return Ball::angle;
}


//Test if ball hits out bounds of the window and return orientation.
char Ball::bounced(sf::RenderWindow & renderWindow) {
	double maxX = renderWindow.GetWidth();
	double maxY = renderWindow.GetHeight();
	char flag = 0;

	//Test collision with sides of the window.
	if (getX() < 0 || getX() > maxX) {
		flag = 's';
	}

	//Test collision with top of the window.
	if (getY() < 0) {
		flag = 't';
	}

	//Test collision with bottom of the window.
	if (getY() > maxY) {
		flag = 'b';
	}

	return flag;
}


void Ball::update(sf::RenderWindow & renderWindow) {
	if (bounced(renderWindow) == 's') {
		setAngle(180 + -getAngle());
	}

	if (bounced(renderWindow) == 't' || bounced(renderWindow) == 'b') {
		setAngle(360 + -getAngle());
	}

	double velocity = 1.0;
	double horz = getX() + easyCos(getAngle());
	double vert = getY() + easySin(getAngle());
	setPosition(horz, vert);
}