#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#include <SFML/System.hpp>
#include <SFML/Graphics.hpp>
#include <iostream>
#include <string>
#include <sstream>
#include "Bat.h"
#include "Ball.h"
#include <math.h>


void drawImage(sf::RenderWindow & renderWindow, sf::Image & image, float x, float y, float scaleWidth, float scaleHeight);
std::string toString(float value);
bool rectsCollided(float x1, float y1, int width1, int height1, float x2, float y2, int width2, int height2);


int main() {
	sf::RenderWindow App(sf::VideoMode(800, 600, 32), "BreakOut SFML C++", sf::Style::Fullscreen);
	//sf::RenderWindow App(sf::VideoMode(800, 600, 32), "BreakOut SFML C++");
	App.ShowMouseCursor(false);

	sf::String Text;

	sf::Image Gradient, Ball01, Bat01;
	if (!Gradient.LoadFromFile("GRADIENT.png") || !Ball01.LoadFromFile("Ball.png") || !Bat01.LoadFromFile("BAT.png")) {
		return 1;
	}

	Bat batObject01 = Bat(App.GetWidth() / 2, App.GetHeight() - 50);
	Ball ballObject01 = Ball(0, 0, 45);

	sf::Event Event;
	while (App.IsOpened()) {
		while (App.GetEvent(Event)) {
			if (Event.Type == sf::Event::Closed) {
				App.Close();
			}

			if (Event.Key.Code == sf::Key::Escape) {
				App.Close();
			}

			batObject01.input(Event);
		}

		drawImage(App, Gradient, 0, 0, 1.0f, 1.0f);
		drawImage(App, Ball01, ballObject01.getX(), ballObject01.getY(), 1.0f, 1.0f);
		drawImage(App, Bat01, batObject01.getX(), batObject01.getY(), 1.0f, 1.0f);

		App.Display();

		ballObject01.update(App);

		//Private scope
		{
			float x1 = batObject01.getX();
			float y1 = batObject01.getY();
			int width1 = Bat01.GetWidth();
			int height1 = Bat01.GetHeight();

			float x2 = ballObject01.getX();
			float y2 = ballObject01.getY();
			int width2 = Ball01.GetWidth();
			int height2 = Ball01.GetHeight();

			if (rectsCollided(x1, y1, width1, height1, x2, y2, width2, height2)) {
				ballObject01.setAngle(360 + -ballObject01.getAngle());
			}
		}
	}

	return 0;
}


void drawImage(sf::RenderWindow & renderWindow, sf::Image & image, float x, float y, float scaleWidth, float scaleHeight) {
	sf::Sprite sprite;
	sprite.SetImage(image);
	sprite.Scale(scaleWidth, scaleHeight);
	sprite.SetPosition(x, y);
	renderWindow.Draw(sprite);
}


std::string toString(float value) {
	std::ostringstream buffer;
	buffer << value;
	return buffer.str();
}


bool rectsCollided(float x1, float y1, int width1, int height1, float x2, float y2, int width2, int height2) {
	bool flag = false;
	
	if (x1 > (x2 - width1) && x1 < (x2 + width2)) {
		if (y1 > (y2 - height1) && y1 < (y2 + height2)) {
			flag = true;
		}
	}

	return flag;
}